module variaveis

! Objetivo: definir as variveis do programa

use PORTLIB	! biblioteca do Fortran

!-------------------------------------------------------------------------------

implicit none

! *** Variveis principais ***

integer :: N       ! nmero de elementos da malha
                   ! nmero de ns = N + 1

integer :: P       ! nmero do n
                   ! P = 0, n no contorno esquerdo
                   ! 1 <= P <= N-1, ns internos
                   ! P = N, n no contorno direito

integer :: fonte   ! tipo do termo fonte: 
                   ! 0 ---> S = e(X)/(e-1)
                   ! 1 ---> S = 0
                   ! 2 ---> S = 2
                   ! 3 ---> S = 6X
                   ! 4 ---> S = 12(X**2)
                   ! onde X  a coordenada espacial

real*8  :: h       ! comprimento de cada elemento da malha

! *** Variveis de interesse ***

real*8 :: T_media          ! temperatura mdia (soluo numrica)
real*8 :: T_media_exato    ! temperatura mdia (soluo analtica)

real*8 :: inclinacao       ! dT/dx em x = 1 (soluo numrica)
real*8 :: inclinacao_exato ! dT/dx em x = 1 (soluo analtica)

! *** Variveis de campo (vetores) com dimenso (0:N) ***

real*8,dimension(:),allocatable :: T_exato ! soluo analtica exata
real*8,dimension(:),allocatable :: T       ! soluo numrica
real*8,dimension(:),allocatable :: x       ! coordenada espacial nodal
real*8,dimension(:),allocatable :: aw      ! coeficiente oeste
real*8,dimension(:),allocatable :: ap      ! coeficiente central
real*8,dimension(:),allocatable :: ae      ! coeficiente leste
real*8,dimension(:),allocatable :: bp      ! termo fonte

! *** vriaveis auxiliares ***

integer, parameter :: in   =  7 ! nmero do arquivo de entrada (dados)
integer, parameter :: out  = 10 ! nmero do arquivo de sada principal
integer, parameter :: out2 = 11 ! nmero do arquivo de sada secundrio

character*50  :: caso      ! nome do arquivo de sada
character*90  :: titulo    ! ttulo do grfico
character*90  :: note_caso ! notepad + caso
logical       :: dos       ! acessa prompt dos

integer :: ver_grafico      ! =1,mostra grficos; 0=no
integer :: ver_coeficientes ! =1,mostra coeficientes de T; 0=no
integer :: ver_campo        ! =1,lista campo de T; 0=no
integer :: w                ! freqncia de impresso dos campos

integer :: k    ! auxiliar
real*8  :: erro ! erro local
real*8  :: cpu  ! tempo de processamento (s)

end